(in-package :araneida)

;;;; this is example code showing you how to set up your own session
;;;; handler.  It's commented out by default because what you want to
;;;; keep in a session-request is probably specific to your
;;;; application and its concept of "session".  Adapt and survive.


;;; Set this up to handle /session/, and it will expect URLS something
;;; like /session/12345dd6789/rest/of/the/URL.  It strips out the id
;;; and puts it in *session* (special), then rewrites the URL and calls
;;; whatever the old handler was

#|
(defvar *session*)

(defun session-request (r exports discriminator arg-string)
  (let* ((pos-slash (position #\/ arg-string))
         (id (subseq arg-string 0 pos-slash))
         (*session* id)
         (rest (subseq arg-string pos-slash nil)))
    (setf discriminator (merge-url (request-url r) rest))
    (change-class r 'session-request)
    (setf (slot-value r 'session) id)
    (dispatch-request r exports discriminator)))

(export-handler (parse-urlstring "http://stargreen.glodfish.telent.net/session/") 'session-request :needs-discriminator t)

|#
